## org.apache.jasper.runtime
Class PageContextImpl

    java.lang.Object
      javax.servlet.jsp.PageContext
          org.apache.jasper.runtime.PageContextImpl

public class PageContextImpl
extends javax.servlet.jsp.PageContext

Implementation of the PageContext class from the JSP spec.

Author:
  Anil K. Vijendran, Larry Cable, Hans Bergsten, Pierre Delisle

Field Summary
`protected java.util.Hashtable` `attributes`
`protected boolean` `autoFlush`
`protected JspWriterImpl` `baseOut`
`protected int` `bufferSize`
`protected javax.servlet.ServletConfig` `config`
`protected javax.servlet.ServletContext` `context`
`protected int` `depth`
`protected java.lang.String` `errorPageURL`
`protected javax.servlet.jsp.JspFactory` `factory`
`protected boolean` `isIncluded`
`protected boolean` `needsSession`
`protected javax.servlet.jsp.JspWriter` `out`
`protected javax.servlet.jsp.tagext.BodyContent[]` `outs`
`protected java.lang.Object` `page`
`protected javax.servlet.ServletRequest` `request`
`protected javax.servlet.ServletResponse` `response`
`protected javax.servlet.Servlet` `servlet`
`protected javax.servlet.http.HttpSession` `session`

Fields inherited from class javax.servlet.jsp.PageContext
`APPLICATION, APPLICATION_SCOPE, CONFIG, EXCEPTION, OUT, PAGE, PAGE_SCOPE, PAGECONTEXT, REQUEST, REQUEST_SCOPE, RESPONSE, SESSION, SESSION_SCOPE`

Method Summary
`protected JspWriterImpl` `_createOut(int bufferSize, boolean autoFlush)`
`java.lang.Object` `findAttribute(java.lang.String name)`
`void` `forward(java.lang.String relativeUrlPath)`
`java.lang.Object` `getAttribute(java.lang.String name)`
`java.lang.Object` `getAttribute(java.lang.String name, int scope)`
`java.util.Enumeration` `getAttributeNamesInScope(int scope)`
`int` `getAttributesScope(java.lang.String name)`
`java.lang.Exception` `getException()`
`javax.servlet.jsp.JspWriter` `getOut()`
`java.lang.Object` `getPage()`
`javax.servlet.ServletRequest` `getRequest()`
`javax.servlet.ServletResponse` `getResponse()`
`javax.servlet.Servlet` `getServlet()`
`javax.servlet.ServletConfig` `getServletConfig()`
`javax.servlet.ServletContext` `getServletContext()`
`javax.servlet.http.HttpSession` `getSession()`
`void` `handlePageException(java.lang.Exception ex)`
`void` `handlePageException(java.lang.Throwable t)`
`void` `include(java.lang.String relativeUrlPath)`
`void` `initialize(javax.servlet.Servlet servlet, javax.servlet.ServletRequest request, javax.servlet.ServletResponse response, java.lang.String errorPageURL, boolean needsSession, int bufferSize, boolean autoFlush)`
`javax.servlet.jsp.JspWriter` `popBody()`
`javax.servlet.jsp.tagext.BodyContent` `pushBody()`
`void` `release()`
`void` `removeAttribute(java.lang.String name)`
`void` `removeAttribute(java.lang.String name, int scope)`
`void` `setAttribute(java.lang.String name, java.lang.Object attribute)`
`void` `setAttribute(java.lang.String name, java.lang.Object o, int scope)`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### outs

    protected javax.servlet.jsp.tagext.BodyContent[] outs

### depth

    protected int depth

### servlet

    protected javax.servlet.Servlet servlet

### config

    protected javax.servlet.ServletConfig config

### context

    protected javax.servlet.ServletContext context

### factory

    protected javax.servlet.jsp.JspFactory factory

### needsSession

    protected boolean needsSession

### errorPageURL

    protected java.lang.String errorPageURL

### autoFlush

    protected boolean autoFlush

### bufferSize

    protected int bufferSize

### attributes

    protected transient java.util.Hashtable attributes

### request

    protected transient javax.servlet.ServletRequest request

### response

    protected transient javax.servlet.ServletResponse response

### page

    protected transient java.lang.Object page

### session

    protected transient javax.servlet.http.HttpSession session

### isIncluded

    protected boolean isIncluded

### out

    protected transient javax.servlet.jsp.JspWriter out

### baseOut

    protected transient JspWriterImpl baseOut

Method Detail

### initialize

    public void initialize(javax.servlet.Servlet servlet,
                           javax.servlet.ServletRequest request,
                           javax.servlet.ServletResponse response,
                           java.lang.String errorPageURL,
                           boolean needsSession,
                           int bufferSize,
                           boolean autoFlush)
                    throws java.io.IOException,
                           java.lang.IllegalStateException,
                           java.lang.IllegalArgumentException

  Throws:
    `java.io.IOException`
    `java.lang.IllegalStateException`
    `java.lang.IllegalArgumentException`

### release

    public void release()

### getAttribute

    public java.lang.Object getAttribute(java.lang.String name)

### getAttribute

    public java.lang.Object getAttribute(java.lang.String name,
                                         int scope)

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.Object attribute)

### setAttribute

    public void setAttribute(java.lang.String name,
                             java.lang.Object o,
                             int scope)

### removeAttribute

    public void removeAttribute(java.lang.String name,
                                int scope)

### getAttributesScope

    public int getAttributesScope(java.lang.String name)

### findAttribute

    public java.lang.Object findAttribute(java.lang.String name)

### getAttributeNamesInScope

    public java.util.Enumeration getAttributeNamesInScope(int scope)

### removeAttribute

    public void removeAttribute(java.lang.String name)

### getOut

    public javax.servlet.jsp.JspWriter getOut()

### getSession

    public javax.servlet.http.HttpSession getSession()

### getServlet

    public javax.servlet.Servlet getServlet()

### getServletConfig

    public javax.servlet.ServletConfig getServletConfig()

### getServletContext

    public javax.servlet.ServletContext getServletContext()

### getRequest

    public javax.servlet.ServletRequest getRequest()

### getResponse

    public javax.servlet.ServletResponse getResponse()

### getException

    public java.lang.Exception getException()

### getPage

    public java.lang.Object getPage()

### include

    public void include(java.lang.String relativeUrlPath)
                 throws javax.servlet.ServletException,
                        java.io.IOException

  Throws:
    `javax.servlet.ServletException`
    `java.io.IOException`

### forward

    public void forward(java.lang.String relativeUrlPath)
                 throws javax.servlet.ServletException,
                        java.io.IOException

  Throws:
    `javax.servlet.ServletException`
    `java.io.IOException`

### pushBody

    public javax.servlet.jsp.tagext.BodyContent pushBody()

### popBody

    public javax.servlet.jsp.JspWriter popBody()

### handlePageException

    public void handlePageException(java.lang.Exception ex)
                             throws java.io.IOException,
                                    javax.servlet.ServletException

  Throws:
    `java.io.IOException`
    `javax.servlet.ServletException`

### handlePageException

    public void handlePageException(java.lang.Throwable t)
                             throws java.io.IOException,
                                    javax.servlet.ServletException

  Throws:
    `java.io.IOException`
    `javax.servlet.ServletException`

### _createOut

    protected JspWriterImpl _createOut(int bufferSize,
                                       boolean autoFlush)
                                throws java.io.IOException,
                                       java.lang.IllegalArgumentException

  Throws:
    `java.io.IOException`
    `java.lang.IllegalArgumentException`

Copyright ? 2000 Apache Software Foundation. All Rights Reserved.